/***************************************************************************
 *   Copyright (C) 2005 by Angelo Rosiello                                 *
 *   angelo@rosiello.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "waiting_syscall.h"
#include "monitor.h"
#include "syscalls.h"

//OVERVIEW: waiting for the right syscall
//REQUIRES: d!=NULL && s!=NULL && pid!=NULL
int waiting_syscall( char *_syscall, unsigned long int descriptor, char *s, unsigned long int pidd )
{
        pid_t pid;
        int scall=0;
        char syscall[10];
	char sys_call[10];
	char sys_call_local[10];
        unsigned char b4[4];
        pid=pidd;

	clean( sys_call );
	clean( sys_call_local );

	if( !strcmp(_syscall, "write") )
		strcpy( sys_call, sys_write );
	else if( !strcmp(_syscall, "send") )
	{
		strcpy( sys_call, sys_socket );
		strcpy( sys_call_local, sys_send );
	}
	else
	{
		printf( "(rhj) %s isn't supported!\n", _syscall);
		return ( -1 ); 
	} 

        while( !scall )
        {
                if( ptrace(PTRACE_GETREGS,pid,&uregs,&uregs) )
                {
                        ptrace( PTRACE_DETACH,pid,1L,0L );
                        perror( "getregs" );
                        return ( -1 );
                }
                *(unsigned long *)&b4[0]=ptrace(PTRACE_PEEKDATA,pid,uregs.eip,&b4[0]);
                if(b4[0]==0xcd && b4[1]==0x80) /* cd 80 = int 80 */
                {
                        scall=1;
                }
                else
                {
			if( singlestep( pid ) == -1 ) return ( -1 );
		}

                if( scall==1 )
                {
                        clean( syscall );
                        sprintf( syscall, "0x%08x", uregs.eax );

                        /* If syscall!=sys_call keep on waiting syscalls */
                        if( strcmp( syscall, sys_call ) )
                        {
                                scall=0;
                                /* Keep on tracing syscalls */
				if( singlestep( pid ) == -1 ) return ( -1 );
			}
			else
			{
                        	ebx=uregs.ebx;
                        	edx=uregs.edx;

				if( sys_call_local[0]=='\0' )
				{

                        		if( ebx!=descriptor || edx<(strlen(s)+1) )
					{		  
                             			scall=0;
	                        		/* Keep on tracing syscalls */
						if( singlestep( pid ) == -1 ) return ( -1 );
					}
				}
				else
				{
					sprintf( syscall, "0x%08x", uregs.ebx );
					if( strcmp(syscall, sys_call_local) )
					{
                                                scall=0;
                                                /* Keep on tracing syscalls */
						if( singlestep( pid ) == -1 ) return ( -1 );
					}
				}
			}
                }	
        }
        return ( 0 );
}

